<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: manage.php
| Author: Christian Damsgaard Jrgensen (PMM)
| Co-Author: Nick Jones (Digitanium)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/admin_header_mce.php";

include INFUSIONS."advanced_custom_pages/infusion_db.php";

if ($settings['tinymce_enabled']) {
	echo "<script language='javascript' type='text/javascript'>advanced();</script>\n";
} else {
	require_once INCLUDES."html_buttons_include.php";
}

if (!checkrights("ACP") || !defined("iAUTH") || $_GET['aid'] != iAUTH) { redirect("../../index.php"); }

if (file_exists(INFUSIONS."advanced_custom_pages/locale/".$settings['locale'].".php")) {
	include INFUSIONS."advanced_custom_pages/locale/".$settings['locale'].".php";
} else {
	include INFUSIONS."advanced_custom_pages/locale/English.php";
}

if (isset($_GET['status']) && !isset($message)) {
	if ($_GET['status'] == "sn") {
		$message = $locale['acp410']."<br />\n".$locale['acp412']."\n<a href='".INFUSIONS."advanced_custom_pages/view.php?page_id=".intval($_GET['pid'])."'>view.php?page_id=".intval($_GET['pid'])."</a>\n";
	} elseif ($_GET['status'] == "su") {
		$message = $locale['acp411']."<br />\n".$locale['acp412']."\n<a href='".INFUSIONS."advanced_custom_pages/view.php?page_id=".intval($_GET['pid'])."'>view.php?page_id=".intval($_GET['pid'])."</a>\n";
	} elseif ($_GET['status'] == "del") {
		$message = $locale['acp413'];
	}
	if ($message) {	echo "<div class='admin-message'>".$message."</div>\n"; }
}

if (isset($_POST['save'])) {
	$page_title = stripinput($_POST['page_title']);
	$page_writer = iSUPERADMIN ? (isnum($_POST['page_writer']) ? $_POST['page_writer'] : "0") : $userdata['user_id'];
	$page_start_date = 0; $page_end_date = 0;
	if ($_POST['page_start']['mday'] != "--" && $_POST['page_start']['mon'] != "--" && $_POST['page_start']['year'] != "----") {
		$page_start_date = mktime($_POST['page_start']['hours'], $_POST['page_start']['minutes'], 0, $_POST['page_start']['mon'], $_POST['page_start']['mday'], $_POST['page_start']['year']);
	}
	if ($_POST['page_end']['mday'] != "--" && $_POST['page_end']['mon'] != "--" && $_POST['page_end']['year'] != "----") {
		$page_end_date = mktime($_POST['page_end']['hours'], $_POST['page_end']['minutes'], 0, $_POST['page_end']['mon'], $_POST['page_end']['mday'], $_POST['page_end']['year']);
	}
	$page_access = isnum($_POST['page_access']) ? $_POST['page_access'] : "0";
	$page_editors = "";
	if (isset($_POST['editors'])) {
		for ($i = 0; $i < count($_POST['editors']); $i++) {
			$page_editors .= ($page_editors != "" ? "." : "").stripinput($_POST['editors'][$i]);
		}
	}
	$page_content = addslash($_POST['page_content']);
	$page_show_writer = isset($_POST['page_show_writer']) ? "1" : "0";
	$page_show_revised = isset($_POST['page_show_revised']) ? "1" : "0";
	$comments = isset($_POST['page_comments']) ? "1" : "0";
	$ratings = isset($_POST['page_ratings']) ? "1" : "0";
	if (isset($_POST['page_id']) && isnum($_POST['page_id'])) {
		$result = dbquery("UPDATE ".DB_ADVANCED_CUSTOM_PAGES." SET page_title='$page_title', page_writer='$page_writer',".($page_start_date != 0 ? " page_datestamp='$page_start_date'," : "")." page_start='$page_start_date', page_end='$page_end_date', page_access='$page_access', page_editors='$page_editors', page_content='$page_content', page_edituser='".$userdata['user_id']."', page_edittime='".time()."', page_show_writer='$page_show_writer', page_show_revised='$page_show_revised', page_allow_comments='$comments', page_allow_ratings='$ratings' WHERE page_id='".$_POST['page_id']."'");
	} else {
		$result = dbquery("INSERT INTO ".DB_ADVANCED_CUSTOM_PAGES." (page_title, page_writer, page_datestamp, page_start, page_end, page_access, page_editors, page_content, page_edituser, page_edittime, page_show_writer, page_show_revised, page_allow_comments, page_allow_ratings) VALUES ('$page_title', '$page_writer', '".($page_start_date != 0 ? $page_start_date : time())."', '$page_start_date', '$page_end_date', '$page_access', '$page_editors', '$page_content', '', '', '$page_show_writer', '$page_show_revised', '$comments', '$ratings')");
		$page_id = mysql_insert_id();
		if (isset($_POST['add_link'])) {
			$data = dbarray(dbquery("SELECT * FROM ".DB_SITE_LINKS." ORDER BY link_order DESC LIMIT 1"));
			$link_order = $data['link_order'] + 1;
			$result = dbquery("INSERT INTO ".DB_SITE_LINKS." (link_name, link_url, link_visibility, link_position, link_window, link_order) VALUES ('$page_title', 'infusions/advanced_custom_pages/view.php?page_id=$page_id', '$page_access', '1', '0', '$link_order')");
		}
	}
	if (isset($_POST['page_id']) && isnum($_POST['page_id'])) {
		redirect(FUSION_SELF.$aidlink."&status=su&pid=".$_POST['page_id'], true);
	} else {
		redirect(FUSION_SELF.$aidlink."&status=sn&pid=".$page_id, true);
	}
} else if (isset($_POST['delete']) && (isset($_POST['page_id']) && isnum($_POST['page_id']))) {
	$result = dbquery("DELETE FROM ".DB_ADVANCED_CUSTOM_PAGES." WHERE page_id='".$_POST['page_id']."'");
	$result = dbquery("DELETE FROM ".DB_SITE_LINKS." WHERE link_url='infusions/advanced_custom_pages/view.php?page_id=".$_POST['page_id']."'");
	redirect(FUSION_SELF.$aidlink."&status=del");
} else {
	if (isset($_POST['preview'])) {
		$addlink = isset($_POST['add_link']) ? " checked='checked'" : "";
		$page_title = stripinput($_POST['page_title']);
		$page_writer = iSUPERADMIN ? $_POST['page_writer'] : $userdata['user_id'];
		$page_start = array(
			"mday" => isnum($_POST['page_start']['mday']) ? $_POST['page_start']['mday'] : "--",
			"mon" => isnum($_POST['page_start']['mon']) ? $_POST['page_start']['mon'] : "--",
			"year" => isnum($_POST['page_start']['year']) ? $_POST['page_start']['year'] : "----",
			"hours" => isnum($_POST['page_start']['hours']) ? $_POST['page_start']['hours'] : "0",
			"minutes" => isnum($_POST['page_start']['minutes']) ? $_POST['page_start']['minutes'] : "0",
		);
		$page_end = array(
			"mday" => isnum($_POST['page_end']['mday']) ? $_POST['page_end']['mday'] : "--",
			"mon" => isnum($_POST['page_end']['mon']) ? $_POST['page_end']['mon'] : "--",
			"year" => isnum($_POST['page_end']['year']) ? $_POST['page_end']['year'] : "----",
			"hours" => isnum($_POST['page_end']['hours']) ? $_POST['page_end']['hours'] : "0",
			"minutes" => isnum($_POST['page_end']['minutes']) ? $_POST['page_end']['minutes'] : "0",
		);
		$page_access = isnum($_POST['page_access']) ? $_POST['page_access'] : "0";
		$page_content = stripslash($_POST['page_content']);
		$page_show_writer = isset($_POST['page_show_writer']) ? " checked='checked'" : "";
		$page_show_revised = isset($_POST['page_show_revised']) ? " checked='checked'" : "";
		$comments = isset($_POST['page_comments']) ? " checked='checked'" : "";
		$ratings = isset($_POST['page_ratings']) ? " checked='checked'" : "";
		opentable($page_title);
		eval("?>".$page_content."<?php ");
		closetable();
		$page_content = phpentities($page_content);
	}
	$result = dbquery("SELECT * FROM ".DB_ADVANCED_CUSTOM_PAGES." ORDER BY page_title");
	if (dbrows($result) != 0) {
		$editlist = ""; $sel = "";
		while ($data = dbarray($result)) {
			$page_editors = explode(".", $data['page_editors']);
			if (iSUPERADMIN || in_array($userdata['user_id'], $page_editors)) {
				$sel = (isset($_POST['page_id']) && $_POST['page_id'] == $data['page_id'] ? " selected='selected'" : "");
				$editlist .= "<option value='".$data['page_id']."'$sel>".$data['page_title']."</option>\n";
			}
		}
		opentable($locale['acp402']);
		echo "<div style='text-align:center'>\n<form name='selectform' method='post' action='".FUSION_SELF.$aidlink."'>\n";
		echo "<select name='page_id' class='textbox' style='width:200px;'>\n".$editlist."</select>\n";
		echo "<input type='submit' name='edit' value='".$locale['acp420']."' class='button' />\n";
		echo "<input type='submit' name='delete' value='".$locale['acp421']."' onclick='return DeletePage();' class='button' />\n";
		echo "</form>\n</div>\n";
		closetable();
	}

	if (isset($_POST['edit']) && (isset($_POST['page_id']) && isnum($_POST['page_id']))) {
		$result = dbquery("SELECT * FROM ".DB_ADVANCED_CUSTOM_PAGES." WHERE page_id='".$_POST['page_id']."'");
		if (dbrows($result)) {
			$data = dbarray($result);
			$page_title = $data['page_title'];
			$page_writer = $data['page_writer'];
			if ($data['page_start'] > 0) $page_start = getdate($data['page_start']);
			if ($data['page_end'] > 0) $page_end = getdate($data['page_end']);
			$page_access = $data['page_access'];
			$page_editors = explode(".", $data['page_editors']);
			$page_content = phpentities(stripslashes($data['page_content']));
			$page_show_writer = ($data['page_show_writer'] == "1" ? " checked='checked'" : "");
			$page_show_revised = ($data['page_show_revised'] == "1" ? " checked='checked'" : "");
			$comments = ($data['page_allow_comments'] == "1" ? " checked='checked'" : "");
			$ratings = ($data['page_allow_ratings'] == "1" ? " checked='checked'" : "");
			$addlink = "";
		} else {
			redirect(FUSION_SELF.$aidlink);
		}
	}
	if (isset($_POST['page_id']) && isnum($_POST['page_id'])) {
		opentable($locale['acp401']);
	} else {
		if (!isset($_POST['preview'])) {
			$page_title = "";
			$page_writer = "";
			$page_start = "";
			$page_end = "";
			$page_access = "";
			$page_editors = "";
			$page_content = "";
			$page_show_writer = " checked='checked'";
			$page_show_revised = " checked='checked'";
			$comments = " checked='checked'";
			$ratings = " checked='checked'";
			$addlink = "";
		}
		opentable($locale['acp400']);
	}
	echo "<form name='inputform' method='post' action='".FUSION_SELF.$aidlink."' onsubmit='return ValidateForm(this);'>\n";
	echo "<table cellpadding='0' cellspacing='0' class='center'>\n<tr>\n";
	echo "<td width='100' class='tbl'>".$locale['acp422']."</td>\n";
	echo "<td width='80%' class='tbl'><input type='text' name='page_title' value='".$page_title."' class='textbox' style='width:98%;' /></td>\n";
	echo "</tr>\n<tr>\n";
	echo "<td valign='top' width='100' class='tbl'>".$locale['acp423']."</td>\n";
	echo "<td width='80%' class='tbl'><textarea name='page_content' cols='95' rows='15' class='textbox' style='width:98%'>".$page_content."</textarea></td>\n";
	echo "</tr>\n<tr>\n";
	if (!$settings['tinymce_enabled']) {
		echo "<td class='tbl'></td><td class='tbl'>\n";
		echo "<input type='button' value='&lt;?php?&gt;' class='button' style='width:60px;' onclick=\"addText('page_content', '&lt;?php\\n', '\\n?&gt;');\" />\n";
		echo "<input type='button' value='&lt;p&gt;' class='button' style='width:35px;' onclick=\"insertText('page_content', '&lt;p&gt;');\" />\n";
		echo "<input type='button' value='&lt;br /&gt;' class='button' style='width:40px;' onclick=\"insertText('page_content', '&lt;br /&gt;');\" />\n";
		echo display_html("inputform", "page_content", true)."</td>\n";
		echo "</tr>\n<tr>\n";
	}
	if (iSUPERADMIN) {
		$result = dbquery("SELECT user_id, user_name, user_level, user_rights FROM ".DB_USERS." WHERE user_level>='102' ORDER BY user_level DESC, user_name");
		if (dbrows($result) != 0) {
			$writers_list = ""; $sel = "";
			while ($data = dbarray($result)) {
				if (in_array("ACP", explode(".", $data['user_rights']))) {
					$sel = (isset($_POST['page_id']) && $_POST['page_id'] == $data['user_id'] ? " selected='selected'" : ($userdata['user_id'] == $data['user_id'] ? " selected='selected'" : ""));
					$writers_list .= "<option value='".$data['user_id']."'".(!isset($_POST['page_id']) || !isnum($_POST['page_id']) ? ($data['user_id'] == $userdata['user_id'] ? " selected='selected'" : "") : ($page_writer == $data['user_id'] ? " selected='selected'" : ""))." />".$data['user_name']."</option>\n";
				}
			}
		}
		echo "<td valign='top' width='100' class='tbl'>".$locale['acp424']."</td>\n";
		echo "<td width='80%' class='tbl'><select name='page_writer' class='textbox' style='width:200px;'>\n".$writers_list."</select></td>\n</tr>\n<tr>\n";
	}
	$user_groups = getusergroups(); $access_opts = ""; $sel = "";
	while (list($key, $user_group) = each($user_groups)) {
		$sel = ($page_access == $user_group['0'] ? " selected='selected'" : "");
		$access_opts .= "<option value='".$user_group['0']."'$sel>".$user_group['1']."</option>\n";
	}
	echo "<td valign='top' width='100' class='tbl'>".$locale['acp425']."</td>\n";
	echo "<td width='80%' class='tbl'><select name='page_access' class='textbox' style='width:200px;'>\n".$access_opts."</select></td>\n</tr>\n<tr>\n";
	$result = dbquery("SELECT user_id, user_name, user_level, user_rights FROM ".DB_USERS." WHERE user_level>='102' ORDER BY user_level DESC, user_name");
	if (dbrows($result) != 0) {
		$editors_list = ""; $i = 0;
		while ($data = dbarray($result)) {
			if (in_array("ACP", explode(".", $data['user_rights']))) {
				if ($data['user_level'] != 103) {
					$editors_list .= "<label><input type='checkbox' name='editors[]' value='".$data['user_id']."'".(isset($_POST['editors'][$i]) ? " checked='checked'" : (!isset($_POST['page_id']) || !isnum($_POST['page_id']) ? ($data['user_id'] == $userdata['user_id'] ? " checked='checked'" : "") : (in_array($data['user_id'], $page_editors) ? " checked='checked'" : "")))." /> ".$data['user_name']."</label><br />\n";
					$i++;
				}
			}
		}
	}
	if ($editors_list != "") {
		echo "<td valign='top' width='100' class='tbl'>".$locale['acp426']."</td>\n";
		echo "<td width='80%' class='tbl'>".$editors_list."</td>\n</tr>\n<tr>\n";
	}
	echo "<td class='tbl'>".$locale['acp427']."</td>\n";
	echo "<td class='tbl'><select name='page_start[mday]' class='textbox'>\n<option>--</option>\n";
	for ($i = 1; $i <= 31; $i++) echo "<option".(isset($page_start['mday']) && $page_start['mday'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> <select name='page_start[mon]' class='textbox'>\n<option>--</option>\n";
	for ($i = 1; $i <= 12; $i++) echo "<option".(isset($page_start['mon']) && $page_start['mon'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> <select name='page_start[year]' class='textbox'>\n<option>----</option>\n";
	for ($i = 2000; $i <= 2015; $i++) echo "<option".(isset($page_start['year']) && $page_start['year'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> / <select name='page_start[hours]' class='textbox'>\n";
	for ($i = 0; $i <= 24; $i++) echo "<option".(isset($page_start['hours']) && $page_start['hours'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> : <select name='page_start[minutes]' class='textbox'>\n";
	for ($i = 0; $i <= 60; $i++) echo "<option".(isset($page_start['minutes']) && $page_start['minutes'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> : 00 ".$locale['acp429']."</td>\n</tr>\n<tr>\n";
	echo "<td class='tbl'>".$locale['acp428']."</td>\n";
	echo "<td class='tbl'><select name='page_end[mday]' class='textbox'>\n<option>--</option>\n";
	for ($i = 1; $i <= 31; $i++) echo "<option".(isset($page_end['mday']) && $page_end['mday'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> <select name='page_end[mon]' class='textbox'>\n<option>--</option>\n";
	for ($i = 1; $i <= 12; $i++) echo "<option".(isset($page_end['mon']) && $page_end['mon'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> <select name='page_end[year]' class='textbox'>\n<option>----</option>\n";
	for ($i = 2000; $i <= 2015; $i++) echo "<option".(isset($page_end['year']) && $page_end['year'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> / <select name='page_end[hours]' class='textbox'>\n";
	for ($i = 0; $i <= 24; $i++) echo "<option".(isset($page_end['hours']) && $page_end['hours'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> : <select name='page_end[minutes]' class='textbox'>\n";
	for ($i = 0; $i <= 60; $i++) echo "<option".(isset($page_end['minutes']) && $page_end['minutes'] == $i ? " selected='selected'" : "").">$i</option>\n";
	echo "</select> : 00 ".$locale['acp429']."</td>\n</tr>\n<tr>\n";
	echo "<td class='tbl'></td><td class='tbl'>\n";
	if (!isset($_POST['page_id']) || !isnum($_POST['page_id'])) {
		echo "<label><input type='checkbox' name='add_link' value='1'".$addlink." />  ".$locale['acp430']."</label><br />\n";
	}
	echo "<label><input type='checkbox' name='page_show_writer' value='1'".$page_show_writer." /> ".$locale['acp431']."</label><br />\n";
	echo "<label><input type='checkbox' name='page_show_revised' value='1'".$page_show_revised." /> ".$locale['acp432']."</label><br />\n";
	echo "<label><input type='checkbox' name='page_comments' value='1'".$comments." /> ".$locale['acp433']."</label><br />\n";
	echo "<label><input type='checkbox' name='page_ratings' value='1'".$ratings." /> ".$locale['acp434']."</label>\n";
	echo "</td>\n</tr>\n<tr>\n";
	echo "<td align='center' colspan='2' class='tbl'><br />\n";
	if (isset($_POST['page_id']) && isnum($_POST['page_id'])) {
		echo "<input type='hidden' name='page_id' value='".$_POST['page_id']."' />\n";
	}
	echo "<input type='submit' name='preview' value='".$locale['acp435']."' class='button' />\n";
	echo "<input type='submit' name='save' value='".$locale['acp436']."' class='button' />\n";
	echo "<input type='reset' name='reset' value='".$locale['acp437']."' class='button' /></td>\n";
	echo "</tr>\n</table>\n</form>\n";
	closetable();
	echo "<script type='text/javascript'>\n"."function DeletePage() {\n";
	echo "return confirm('".$locale['acp450']."');\n}"."\n";
	echo "function ValidateForm(frm) {\n"."if(frm.page_title.value=='') {\n";
	echo "alert('".$locale['acp451']."');\n"."return false;\n}\n}\n";
	echo "</script>\n";
}

require_once THEMES."templates/footer.php";
?>